debug_output = true -- true/false --display debug messages in the console

-----DISPLAY CONSOLE MESSAGE----------------------------------------------------

-- Display a message in the console for debugging, message can be a number variable
-- or a string but not mixed. No line feed character is added.
function Msg(value)
  --returns nothing

  if debug_output then --check if flag is set true (at the start of this script)
    reaper.ShowConsoleMsg(tostring(value).."\n")
  end
end

function print(value)

 reaper.ShowConsoleMsg(tostring(value).."\n")
end


function import_sel_trk_btn_click()

  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
  import_riff = 1
  gen_cur_track_sec_btn_click()


end


function gen_cur_track_sec_btn_click()

  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  

  import_riff = 0
  
  cur_pos2 = reaper.GetCursorPosition()
  --wait(10)
  --reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_track_info.ahk"]],0)
  --reaper.MB("Wait for temp.txt","wait",0)
  --wait(3)
  
  
  sep = "\t" -- default sep
  popup = true
  
  --[[
  col_pos = 3 -- Position column index in the CSV
  col_pos_end = 4 -- Length column index in the CS
  col_len = 5 -- Length column index in the CSV
  col_name = 2 -- Name column index in the CSV
  col_color = 6
  --]]
  col_id = 1
  col_data = 3
  col_source = 4
  col_bpm = 5
  col_timesig = 8
  col_source_start = 9 -- - (beats * 1200) 
  col_source_offset = 12
  col_source_end = 13 -- / 1200 (/col_timesig)
  col_source_dest = 18
  col_bar_dest = 20 -- +3 including count-in
  col_transpose = 23
  col_is_drums = 29
  
  
  retval_ppq, ppq_set = reaper.BR_Win32_GetPrivateProfileString("reaper", "miditicksperbeat", "", inipath) 
  --retval, filetxt = reaper.GetUserFileNameForRead("", "Import RT RD Sections text", "txt")
  --Msg("Run bb_track_info.ahk")
  --reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/bb_track_info.ahk"]],-2)
  
  --wait(3)
  --letter = GUI.Val("my_mnu3")
  --drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  filetxt = [[C:\bb\Data\temp.txt]]
  if filetxt then
  
    --reaper.Main_OnCommand( 40289, 0 ) -- Item: Unselect (clear selection of) all items
    
    --reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
    
    
    reaper.PreventUIRefresh(1)
  
    reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
    
    reaper.ClearConsole()
  
    read_lines(filetxt)
    
    --reaper.SetEditCurPos( pos_start, 0, 0 )
    
  
    
    -- reaper.Main_OnCommand( reaper.NamedCommandLookup( "_SWSMARKERLIST10" ), -1) -- SWS: Delete all regions
  
    main2()
  
    reaper.Undo_EndBlock("Import RT RD Sections", -1) -- End of the undo block. Leave it at the bottom of your main function.
    --Msg("pos_start "..pos_start)
    --reaper.SetEditCurPos( pos_start, 0, 0 )
    --reaper.MoveEditCursor( cur_pos2, 0 )
    
    reaper.Main_OnCommand(40042,0)
    
    reaper.UpdateArrange()
  
    reaper.PreventUIRefresh(-1)
  
  end
  --reaper.MoveEditCursor( cur_pos2, 0 )
  --reaper.Main_OnCommand(40848, 0) -- View: Restore previous zoom/scroll position
  
::gen_cur_track_sec_end::
no_loop = 0

pos_start, pos_end = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
reaper.MoveEditCursor( pos_start, 0 )
 
end


function read_lines(filepath)
  --Msg("filepath "..filepath)
  lines = {}

  local f = io.input(filepath)
  repeat

    s = f:read ("*l") -- read one line

    if s then  -- if not end of file (EOF)
      table.insert(lines, ParseCSVLine (s,sep))
    end

  until not s  -- until end of file

  f:close()

end


function main2()

  drums = 0

  folder = filetxt:match[[^@?(.*[\/])[^\/]-$]]

  for i, line in ipairs( lines ) do
    if i > 0 then

      -- Name Variables
      --[[
      local pos = tonumber(line[col_pos])
      local pos_end = tonumber(line[col_pos_end])
      local len =  tonumber( line[col_len] )
      local name = line[col_name]
      local color = 0
      
      PN2719-2.WAV
      
      col_id = 1
      col_data = 2
      col_source = 3
      col_bpm = 4
      col_timesig = 7
      col_source_start = 8 -- - (beats * 1200) 
      col_source_end = 12 -- / 1200 (/col_timesig)
      col_source_dest = 17
      col_bar_dest = 19 -- +3 including count-in
      col_transpose = 22
      --]]
      d = 0
      ps = 0
      pitch = ""
      
      
      local is_data = tonumber(line[col_data])
      
      
      
      if is_data == 1 then
        local source = line[col_source]
        local source_bpm = tonumber(line[col_bpm])
        local time_sig = tonumber(line[col_timesig])
        local source_start = tonumber(line[col_source_start])
        local source_end = tonumber(line[col_source_end]) 
        local source_offset = (line[col_source_offset])
        local source_dest = tonumber(line[col_source_dest])
        local transpose = tonumber(line[col_transpose])
        local d = tonumber(line[col_is_drums])
        --filename = GetFilename(source)
        --Msg("source "..source)
        if source then 
          RT_track_name = string.match(source, "RealTracks\\(.+)\\")  -- Msg("RT_track_name "..RT_track_name) end
        --elseif source then RT_track_name = string.match(source, "Drums\\(.+).WAV") 
        end
        
 
        
        if string.match(source, "Holds") then
          --Msg("Hold")
          --Msg(source_bpm)
          --source_bpm =  80
        end
       
        
        if string.find(source, "+1.") then pitch = "+1" end
        if string.find(source, "+2.") then pitch = "+2" end
        if string.find(source, "+3.") then pitch = "+3" end
        if string.find(source, "+4.") then pitch = "+4" end
        if string.find(source, "-1.") then pitch = "-1" end
        if string.find(source, "-2.") then pitch = "-2" end
        if string.find(source, "-3.") then pitch = "-3" end
        if string.find(source, "-4.") then pitch = "-4" end
        
        
        if pitch == "" then pitch = 0 ps = 15 end
        
        
        --pitch = tonumber(round(pitch))
        --Msg("pitch "..pitch)
        if ps ~= 15 then
          source = source:gsub(pitch..".", ".")
        end
        
        RTextension =1 -- pos 2 in array .wav -- GUI.Val("my_mnu2")
        
        file_type = {".wma",".wav",".aiff",".flac",".mp3",".wv",".ogg"}
        
        source = source:gsub(".WAV", file_type[RTextension])
        
        if string.find(source,"Drums") then
          drums = 1
          
        else
          drums = 0
        end
        
        source_offset = source_offset:gsub("-", "")
        
        source_offset = 0
        
        --Msg("source "..source)
        --Msg("source bpm "..source_bpm)
        --Msg("time sig "..time_sig)
        --Msg("source start "..source_start)
        --Msg("source end "..source_end)
        --Msg("source dest "..source_dest)
        --Msg("transpose "..transpose)
         
        --if d == 1 then  
        --  offset = 50 
        --else offset = 0  
        --end
        
        
        bpm =  reaper.Master_GetTempo()
        
        pitch = pitch + transpose
        
        track_pos = ""
        
        reaper.InsertMedia( source, 0 )
        
        sel_item =reaper.GetSelectedMediaItem( 0, 0 )
        
        --instrument_name = getFolderName(source)
        
        --instrument_name1 = getFolderName2(source)
        
        
        
        --instrument_name = instrument_name1:gsub(" Direct Input", "")
        
        --Msg(
        --Msg("instrument_name1 "..instrument_name1)
        
        --instrument_path = (string.gsub(source, start_path, "")) 
        
        
        
        --Msg(instrument_name)
        
        --if i == 1 then
          --current_track = reaper.GetMediaItem_Track( sel_item )
          --current_track = reaper.GetSelectedTrack2( 0, 0, 1 )
          --reaper.GetSetMediaTrackInfo_String(current_track, "P_NAME", instrument_name, true)
        
        --end
        
        sel_take = reaper.GetTake( sel_item, 0 )
        
        playrate = (bpm / source_bpm)
        
        source_beat_start = (((source_start + source_offset) / 1200) ) --- (1200 * time_sig)
        
        source_beat_end = (((source_end + source_offset) / 1200) ) --- (1200 * time_sig)
        
        source_beat_length = source_beat_end - source_beat_start
        
        source_time_length = ((source_beat_length / source_bpm) * 60)
        
        source_time_pos = ((source_beat_start / source_bpm) * 60)
        
        track_beat_pos = (source_dest / 1200)
        
        track_time_pos = reaper.TimeMap2_beatsToTime( 0, track_beat_pos )
        
        track_time_pos_end = reaper.TimeMap2_beatsToTime( 0, track_beat_pos + source_beat_length )
        
        --track_time_pos = (((track_beat_pos) / bpm) * 60)
        
        --track_item_length = ((source_beat_length / bpm) * 60)
        
        --Msg("track time pos "..track_time_pos)
        --Msg("source_beat_length "..source_beat_length)
        --Msg("source_time_length "..source_time_length)
        --Msg("source_beat_start "..source_beat_start)
        --Msg("source_beat_end "..source_beat_end)
        --Msg("track_time_pos "..track_time_pos)
       -- Msg("track_beat_pos "..track_beat_pos)
        
        
        --reaper.SetMediaItemTakeInfo_Value( sel_take, "D_PLAYRATE", playrate ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS"
        
        reaper.SetMediaItemTakeInfo_Value( sel_take, "D_PITCH", pitch ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS"
        
        reaper.SetMediaItemTakeInfo_Value( sel_take, "D_STARTOFFS", source_time_pos ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS"        
        
        reaper.SetMediaItemInfo_Value( sel_item, "D_POSITION", track_time_pos ) -- "D_POSITION"  "D_LENTH"
        
       -- reaper.SetMediaItemInfo_Value( sel_item, "D_LENTH", source_time_length ) -- "D_POSITION"  "D_LENTH"
        
        reaper.SetMediaItemLength(sel_item, source_time_length, true)
        
        stretch_item_to_pos(track_time_pos_end)
        
        reaper.SetMediaItemInfo_Value( sel_item, "C_BEATATTACHMODE", 1 )
         
        reaper.SetMediaItemInfo_Value( sel_item, "C_AUTOSTRETCH", 1 )
        
        -- Msg("SET")
        
        reaper.Main_OnCommand( 40289, 0 ) -- Item: Unselect (clear selection of) all items
        
        --if i > 2 then break end
        --reaper.SetMediaItemPosition(sel_item, number position, boolean refreshUI)
  
        --reaper.UpdateArrange()
      
        --reaper.AddProjectMarker2( 0, is_region, pos + cur_pos, pos_end + cur_pos, name, -1, color )
      end

    end
  end
  current_track = reaper.GetSelectedTrack( 0, 0 )
  --current_track = reaper.GetTrack( 0, sel_track )
  --current_track = reaper.GetSelectedTrack2( 0, 0, 1 )
  if RT_track_name then
    --Msg(RT_track_name)
    reaper.GetSetMediaTrackInfo_String(current_track, "P_NAME", RT_track_name, true)  
  end
end


-- CSV to Table
-- http://lua-users.org/wiki/LuaCsv
function ParseCSVLine (line,sep)
  local res = {}
  local pos = 1
  sep = sep or ','
  while true do
    local c = string.sub(line,pos,pos)
    if (c == "") then break end
    if (c == '"') then
      -- quoted value (ignore separator within)
      local txt = ""
      repeat
        local startp,endp = string.find(line,'^%b""',pos)
        txt = txt..string.sub(line,startp+1,endp-1)
        pos = endp + 1
        c = string.sub(line,pos,pos)
        if (c == '"') then txt = txt..'"' end
        -- check first char AFTER quoted string, if it is another
        -- quoted string without separator, then append it
        -- this is the way to "escape" the quote char in a quote. example:
        --   value1,"blub""blip""boing",value3  will result in blub"blip"boing  for the middle
      until (c ~= '"')
      table.insert(res,txt)
      assert(c == sep or c == "")
      pos = pos + 1
    else
      -- no quotes used, just look for the first separator
      local startp,endp = string.find(line,sep,pos)
      if (startp) then
        table.insert(res,string.sub(line,pos,startp-1))
        pos = endp + 1
      else
        -- no separator found -> use rest of string and terminate
        table.insert(res,string.sub(line,pos))
        break
      end
    end
  end
  return res
end


function stretch_item_to_pos(xpos)

  item = reaper.GetSelectedMediaItem(0, 0)
  take = reaper.GetActiveTake(item)
  rate = reaper.GetMediaItemTakeInfo_Value(take, "D_PLAYRATE")
  pos = reaper.GetMediaItemInfo_Value(item, "D_POSITION")
  length = reaper.GetMediaItemInfo_Value(item, "D_LENGTH")
  snapoffset = reaper.GetMediaItemInfo_Value(item, "D_SNAPOFFSET")
  
  invsnapoffset = length - snapoffset
  snapoffset_pos = pos + snapoffset
  item_end = pos + length
  editcur = xpos --reaper.GetCursorPosition()
  abs_beetween = math.abs(snapoffset_pos - editcur)
  itemcenter = pos + length/2
  k = 1
  
  if snapoffset ~= 0 then
    if editcur < snapoffset_pos then
      k = abs_beetween / snapoffset
      newlength = item_end - editcur
      newpos = editcur
      newsnapoffset = snapoffset * k 
      snapoffset0 = snapoffset * rate
      reaper.SetTakeStretchMarker(take, -1, 0)
      reaper.SetTakeStretchMarker(take, -1, snapoffset0)
    end  
  
    if editcur > snapoffset_pos then
      k = abs_beetween / invsnapoffset
      newlength = editcur - pos
      newpos = pos
      newsnapoffset = snapoffset
      snapoffset0 = snapoffset * rate
      length0 = length * rate
      reaper.SetTakeStretchMarker(take, -1, snapoffset0)
      reaper.SetTakeStretchMarker(take, -1, length0)
    end
    if editcur == snapoffset_pos then
      newlength = length
      newpos = pos
      newsnapoffset = snapoffset
    end
  reaper.SetMediaItemInfo_Value(item, "D_SNAPOFFSET", newsnapoffset)    
  end
  
  if snapoffset == 0 then
    if editcur < itemcenter then
      fut_lenght = item_end - editcur
      k = fut_lenght / length
      newlength = length * k
      newpos = editcur
    end
    if editcur > itemcenter then
      fut_length = editcur - pos
      k = fut_length / length
      newlength = length * k
      newpos = editcur - newlength
    end
    if editcur == itemcenter then
      newlength = length
      newpos = pos
    end
    newrate = rate / k 
    reaper.SetMediaItemTakeInfo_Value(take, "D_PLAYRATE", newrate)  
  end
     
  reaper.SetMediaItemInfo_Value(item, "D_POSITION", newpos)
  reaper.SetMediaItemInfo_Value(item, "D_LENGTH", newlength)
   
  
  if snapoffset ~= 0 then
    if editcur < snapoffset_pos then
      newsnapoffset0 = (snapoffset_pos - newpos) * rate
      reaper.SetTakeStretchMarker(take, 1, newsnapoffset0)
    end
    if editcur > snapoffset_pos then
      newlength0 = (editcur - newpos) * rate
      reaper.SetTakeStretchMarker(take, 0, snapoffset0)
      reaper.SetTakeStretchMarker(take, 1, newlength0)
    end
  end

end


import_sel_trk_btn_click() --run
